\section{Route Parameters}

URL components can be assigned to
\hyperref[sec:http:params]{parameters} too by the
\hyperref[sec:intro:routes]{Routes} too. For example,
\Literal{/hello/world} could be arranged to call the handler for
\texttt{hello} and assign the value \Literal{world} to a parameter.

\lstinputlisting[caption=Route puttinng a path into a parameter (HTTPRouteParams).]{FunctionalWebExamples/Source/HTTP/RouteParams.hs}

This combines the original \hyperref[sec:intro:routes]{Routes} example
with some new code. First there's a new route with a parameter named
\Literal{hello/:world}.

\lstinputlisting[linerange=11-13,firstnumber=11,caption=The \Literal{hello/:world} route.]{FunctionalWebExamples/Source/HTTP/RouteParams.hs}

We've also defined a \Literal{hello} function to handle both this
route and the \Literal{hello} route with no parameter. It also uses
the \hyperref[sec:http:headers:maybe]{\maybe} function since the parameter
may not be supplied.

\lstinputlisting[linerange=16-21,firstnumber=16,caption=The \Literal{hello} handler.]{FunctionalWebExamples/Source/HTTP/RouteParams.hs}

This uses \maybe, just like the \hyperref[sec:http:params]{parameters}
example did. It also joins all the values provided for the parameter,
combines them with \Literal{|}, and writes them to the browser. If
there's no parameter, it'll report that as well.

\subsection{Exercise}

\begin{Exercise}[difficulty=1,title=Add another route with another parameter.]
Add another route that takes a parameter. Also experiment with adding matching query parameters.
\end{Exercise}

\begin{Exercise}[difficulty=2,title=Experiment with \Literal{empty}]
    Replace the \Literal{noWorld} function with \Literal{empty} and
    remove it's definition from the \Literal{where} clause.
\end{Exercise}

%%% Local Variables:
%%% mode: latex
%%% TeX-master: "../../FunctionalWeb"
%%% End:
